searchNodes=[{"doc":"Flop is a helper library for filtering, ordering and pagination with Ecto.UsageDerive Flop.Schema in your Ecto schemas.defmodule Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age]} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string field :social_security_number, :string end endValidate a parameter map to get a Flop.t/0 struct with Flop.validate/1. Add the Flop.t/0 to a Ecto.Queryable.t/0 with Flop.query/2.iex&gt; params = %{&quot;order_by&quot; =&gt; [&quot;name&quot;, &quot;age&quot;], &quot;limit&quot; =&gt; 5} iex&gt; {:ok, flop} = Flop.validate(params, for: Flop.Pet) {:ok, %Flop{ filters: [], limit: 5, offset: nil, order_by: [:name, :age], order_directions: nil, page: nil, page_size: nil }} iex&gt; Flop.Pet |&gt; Flop.query(flop) #Ecto.Query&lt;from p0 in Flop.Pet, order_by: [asc: p0.name, asc: p0.age], limit: ^5&gt;","ref":"Flop.html","title":"Flop","type":"module"},{"doc":"Applies the filter parameter of a Flop.t/0 to an Ecto.Queryable.t/0.Used by Flop.query/2.","ref":"Flop.html#filter/2","title":"Flop.filter/2","type":"function"},{"doc":"Applies the order_by and order_directions parameters of a Flop.t/0 to an Ecto.Queryable.t/0.Used by Flop.query/2.","ref":"Flop.html#order_by/2","title":"Flop.order_by/2","type":"function"},{"doc":"Applies the pagination parameters of a Flop.t/0 to an Ecto.Queryable.t/0.The function supports both offset/limit based pagination and page/page_size based pagination.If you validated the Flop.t/0 with Flop.validate/1 before, you can be sure that the given Flop.t/0 only has pagination parameters set for one pagination method. If you pass an unvalidated Flop.t/0 that has pagination parameters set for multiple pagination methods, this function will arbitrarily only apply one of the pagination methods.Used by Flop.query/2.","ref":"Flop.html#paginate/2","title":"Flop.paginate/2","type":"function"},{"doc":"Adds clauses for filtering, ordering and pagination to a Ecto.Queryable.t/0.The parameters are represented by the Flop.t/0 type. Any nil values will be ignored.Examplesiex&gt; flop = %Flop{limit: 10, offset: 19} iex&gt; Flop.query(Flop.Pet, flop) #Ecto.Query&lt;from p0 in Flop.Pet, limit: ^10, offset: ^19&gt;Or enhance an already defined query:iex&gt; require Ecto.Query iex&gt; flop = %Flop{limit: 10} iex&gt; Flop.Pet |&gt; Ecto.Query.where(species: &quot;dog&quot;) |&gt; Flop.query(flop) #Ecto.Query&lt;from p0 in Flop.Pet, where: p0.species == &quot;dog&quot;, limit: ^10&gt;","ref":"Flop.html#query/2","title":"Flop.query/2","type":"function"},{"doc":"Validates a Flop.t/0.Examplesiex&gt; params = %{&quot;limit&quot; =&gt; 10, &quot;offset&quot; =&gt; 0, &quot;texture&quot; =&gt; &quot;fluffy&quot;} iex&gt; Flop.validate(params) {:ok, %Flop{ filters: [], limit: 10, offset: 0, order_by: nil, order_directions: nil, page: nil, page_size: nil }} iex&gt; flop = %Flop{offset: -1} iex&gt; {:error, changeset} = Flop.validate(flop) iex&gt; changeset.valid? false iex&gt; changeset.errors [ offset: {&quot;must be greater than or equal to %{number}&quot;, [validation: :number, kind: :greater_than_or_equal_to, number: 0]} ]It also makes sure that only one pagination method is used.iex&gt; params = %{limit: 10, offset: 0, page: 5, page_size: 10} iex&gt; {:error, changeset} = Flop.validate(params) iex&gt; changeset.valid? false iex&gt; changeset.errors [limit: {&quot;cannot combine multiple pagination types&quot;, []}]If you derived Flop.Schema in your Ecto schema to define the filterable and sortable fields, you can pass the module name to the function to validate that only allowed fields are used.iex&gt; params = %{&quot;order_by&quot; =&gt; [&quot;social_security_number&quot;]} iex&gt; {:error, changeset} = Flop.validate(params, for: Flop.Pet) iex&gt; changeset.valid? false iex&gt; [order_by: {msg, [_, {_, enum}]}] = changeset.errors iex&gt; msg &quot;has an invalid entry&quot; iex&gt; enum [:name, :age, :species]Note that currently, trying to use an existing field that is not allowed as seen above will result in the error message has an invalid entry, while trying to use a field name that does not exist in the schema (or more precisely: a field name that doesn't exist as an atom) will result in the error message is invalid. This might change in the future.","ref":"Flop.html#validate/2","title":"Flop.validate/2","type":"function"},{"doc":"Represents the supported order direction values.","ref":"Flop.html#t:order_direction/0","title":"Flop.order_direction/0","type":"type"},{"doc":"Represents the query parameters for filtering, ordering and pagination.Fieldslimit, offset: Used for pagination. May not be used together with page and page_size.page, page_size: Used for pagination. May not be used together with limit and offset.order_by: List of fields to order by. Fields can be restricted by deriving Flop.Schema in your Ecto schema.order_directions: List of order directions applied to the fields defined in order_by. If empty or the list is shorter than the order_by list, :asc will be used as a default for each missing order direction.filters: List of filters, see Flop.Filter.t/0.","ref":"Flop.html#t:t/0","title":"Flop.t/0","type":"type"},{"doc":"Defines a filter.","ref":"Flop.Filter.html","title":"Flop.Filter","type":"module"},{"doc":"Represents valid filter operators.","ref":"Flop.Filter.html#t:op/0","title":"Flop.Filter.op/0","type":"type"},{"doc":"Represents filter query parameters.Fieldsfield: The field the filter is applied to. The allowed fields can be restricted by deriving Flop.Schema in your Ecto schema.op: The filter operator.value: The comparison value of the filter.","ref":"Flop.Filter.html#t:t/0","title":"Flop.Filter.t/0","type":"type"},{"doc":"This protocol allows you to define the sortable and filterable fields in your Ecto schemas.UsageDerive Flop.Schema in your Ecto schema.defmodule Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age]} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string field :social_security_number, :string end endAfter that, you can pass the module as the :for option to Flop.validate/2.iex&gt; Flop.validate(%Flop{order_by: [:name]}, for: Flop.Pet) {:ok, %Flop{ filters: [], limit: nil, offset: nil, order_by: [:name], order_directions: nil, page: nil, page_size: nil }} iex&gt; {:error, changeset} = Flop.validate( ...&gt; %Flop{order_by: [:social_security_number]}, for: Flop.Pet ...&gt; ) iex&gt; changeset.valid? false iex&gt; changeset.errors [ order_by: {&quot;has an invalid entry&quot;, [validation: :subset, enum: [:name, :age, :species]]} ]Defining default and maximum limitsTo define a default or maximum limit, you can set the default_limit and max_limit option when deriving Flop.Schema. The maximum limit will be validated and the default limit applied by Flop.validate/1.@derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age], max_limit: 100, default_limit: 50}","ref":"Flop.Schema.html","title":"Flop.Schema","type":"protocol"},{"doc":"Returns the default limit of a schema.iex&gt; Flop.Schema.default_limit(%Flop.Fruit{}) 50","ref":"Flop.Schema.html#default_limit/1","title":"Flop.Schema.default_limit/1","type":"function"},{"doc":"Returns the filterable fields of a schema.iex&gt; Flop.Schema.filterable(%Flop.Pet{}) [:name, :species]","ref":"Flop.Schema.html#filterable/1","title":"Flop.Schema.filterable/1","type":"function"},{"doc":"Returns the maximum limit of a schema.iex&gt; Flop.Schema.max_limit(%Flop.Pet{}) 20","ref":"Flop.Schema.html#max_limit/1","title":"Flop.Schema.max_limit/1","type":"function"},{"doc":"Returns the sortable fields of a schema.iex&gt; Flop.Schema.sortable(%Flop.Pet{}) [:name, :age, :species]","ref":"Flop.Schema.html#sortable/1","title":"Flop.Schema.sortable/1","type":"function"},{"doc":"","ref":"Flop.Schema.html#t:t/0","title":"Flop.Schema.t/0","type":"type"},{"doc":"FlopFlop is an Elixir library for making filtering, ordering and pagination with Ecto a bit easier.This library is in early development.","ref":"readme.html","title":"Flop","type":"extras"},{"doc":"ordering by multiple fields in multiple directionsoffset/limit based paginationpage number/page size based paginationfiltering by multiple conditions with diverse operators on multiple fieldsparameter validationconfigurable filterable and sortable fields","ref":"readme.html#features","title":"Flop - Features","type":"extras"},{"doc":"See https://github.com/woylie/flop/projects/1","ref":"readme.html#to-do","title":"Flop - To Do","type":"extras"},{"doc":"Add flop to your list of dependencies in mix.exs:def deps do [ {:flop, &quot;~&gt; 0.4.0&quot;} ] end","ref":"readme.html#installation","title":"Flop - Installation","type":"extras"},{"doc":"Define sortable and filterable fieldsIf you want the order by and filter fields to be validated, configure the sortable and filterable fields in your Ecto schema like this:defmodule MyApp.Pet do use Ecto.Schema @derive {Flop.Schema, filterable: [:name, :species], sortable: [:name, :age, :species]} schema &quot;pets&quot; do field :name, :string field :age, :integer field :species, :string field :social_security_number, :string end endQueryingThe most important functions are Flop.query/2 and Flop.validate/2. You can use them like this:defmodule MyApp.Pets do import Ecto.Query, warn: false alias Ecto.Changeset alias Flop alias MyApp.{Pet, Repo} @spec list_pets(Flop.t()) :: {:ok, [Pet.t()]} | {:error, Changeset.t()} def list_pets(flop \\\\ %Flop{}) do with {:ok, flop} &lt;- Flop.validate(flop, for: Pet) do pets = Pet |&gt; Flop.query(flop) |&gt; Repo.all() {:ok, pets} end end endIf you didn't derive Flop.Schema as described above and don't care to do so, just call the validate function without the second parameter: Flop.validate(flop).PhoenixIf you are using Phoenix, you might prefer to validate the Flop parameters in your controller instead.defmodule MyAppWeb.PetController do use MyAppWeb, :controller alias Flop alias MyApp.Pets alias MyApp.Pets.Pet action_fallback MyAppWeb.FallbackController def index(conn, params) do with {:ok, flop} &lt;- Flop.validate(params, for: Pet) do pets = Pets.list_pets(flop) render(conn, &quot;index.html&quot;, pets: pets) end end end defmodule MyApp.Pets do import Ecto.Query, warn: false alias Flop alias MyApp.Pets.Pet alias MyApp.Repo @spec list_pets(Flop.t()) :: [Pet.t()] def list_pets(flop \\\\ %Flop{}) do Pet |&gt; Flop.query(flop) |&gt; Repo.all() end end","ref":"readme.html#usage","title":"Flop - Usage","type":"extras"}]